--- gdm-2.30.6/daemon/simple-slave-main.c-orig	2011-07-27 22:39:00.175370529 -0500
+++ gdm-2.30.6/daemon/simple-slave-main.c	2011-07-27 22:39:53.643306968 -0500
@@ -154,6 +154,15 @@ on_slave_stopped (GdmSlave   *slave,
         g_main_loop_quit (main_loop);
 }
 
+static void
+on_slave_failed (GdmSlave   *slave,
+                 GMainLoop  *main_loop)
+{
+        g_debug ("slave failed");
+        gdm_return_code = 1;
+        g_main_loop_quit (main_loop);
+}
+
 static gboolean
 is_debug_set (void)
 {
@@ -256,6 +265,10 @@ main (int    argc,
                           "stopped",
                           G_CALLBACK (on_slave_stopped),
                           main_loop);
+        g_signal_connect (slave,
+                          "failed",
+                          G_CALLBACK (on_slave_failed),
+                          main_loop);
         gdm_slave_start (slave);
 
         g_main_loop_run (main_loop);
